(function (Drupal) {
  "use strict";

  /**
   * @type {{attach: Drupal.behaviors.initOuibounce.attach}}
   */
  Drupal.behaviors.initOuibounce = {
    attach: function (context, settings) {
      once('init-ouibounce', document.getElementById('ouibounce-exit-modal'), context).forEach(function (item) {
        var config = settings['ouibounce'];
        var modal = item.getElementsByClassName("modal")[0];
        var footer = modal ? modal.getElementsByClassName("modal-footer")[0] : null;

        ouibounce(item, {
          sensitivity: config['sensitivity'],
          aggressive: config['aggressive_mode'],
          timer: config['timer'],
          delay: config['delay'],
          cookieExpire: config['cookie_expiration'],
          cookieDomain: config['cookie_domain'],
          cookieName: config['cookie_name'],
          sitewide: config['sitewide_cookie'],
          callback: function () {
          }
        });

        document.body.addEventListener('click', function (e) {
          item.style.display = 'none';
        });

        if(footer)
        {
          footer.addEventListener('click', function (e) {
            item.style.display = 'none';
          });
        }

        if(modal)
        {
          modal.addEventListener('click', function (e) {
            e.stopPropagation();
          });
        }
      });
    }
  };

})(Drupal);
